﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinTree;

namespace WindowsFormsApplication348
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        Point nodePoint;
        private void ultraTree1_MouseDown(object sender, MouseEventArgs e)
        {
            nodePoint = new Point(e.X, e.Y);
        }

        private void ultraTree1_MouseMove(object sender, MouseEventArgs e)
        {
            UltraTree sourceTree = sender as UltraTree;

            if (e.Button == MouseButtons.Left)
            {
                Point cursorPos = new Point(e.X, e.Y);

                Rectangle dragRect = new Rectangle(this.nodePoint, SystemInformation.DragSize);
                dragRect.X -= SystemInformation.DragSize.Width / 2;
                dragRect.Y -= SystemInformation.DragSize.Height / 2;

                if (dragRect.Contains(cursorPos))
                    sourceTree.DoDragDrop(sourceTree.ActiveNode, DragDropEffects.All);
            }
        }

        private void ultraStatusBar2_DragOver(object sender, DragEventArgs e)
        {
            e.Effect = DragDropEffects.All;
        }

        private void ultraStatusBar2_DragDrop(object sender, DragEventArgs e)
        {            
            ultraStatusBar2.Panels.Add(ultraTree1.ActiveNode.Key, ultraTree1.ActiveNode.Text);
        }
    }
}
